# Required - Retrieves environment variables
data "azurerm_subscription" "primary" {}

data "azuread_service_principal" "cspm" {
  display_name = var.display_name
}


# Required Roles
resource "azurerm_role_assignment" "log_analytics_reader" {
  scope              = data.azurerm_subscription.primary.id         # Can be further assigned if restricting the Arctic Wolf scanner to a specific tenant
  role_definition_id = "${data.azurerm_subscription.primary.id}/providers/Microsoft.Authorization/roleDefinitions/73c42c96-874c-492b-b04d-ab87d138a893"       # https://learn.microsoft.com/en-us/azure/role-based-access-control/built-in-roles
  principal_id       = data.azuread_service_principal.cspm.object_id
        depends_on = [
          data.azuread_service_principal.cspm
        ]
}

resource "azurerm_role_assignment" "security_reader" {
    scope               = data.azurerm_subscription.primary.id      # Can be further assigned if restricting the Arctic Wolf scanner to a specific tenant
    role_definition_id  = "${data.azurerm_subscription.primary.id}/providers/Microsoft.Authorization/roleDefinitions/39bc4728-0917-49c7-9d2c-d95423bc2eb4"    # https://learn.microsoft.com/en-us/azure/role-based-access-control/built-in-roles
    principal_id        = data.azuread_service_principal.cspm.object_id
        depends_on = [
          data.azuread_service_principal.cspm
        ]
}

# Required Outputs
output "security_reader_role_assignment" {
  value = azurerm_role_assignment.log_analytics_reader.role_definition_name
}

output "log_analytics_role_assignment" {
  value = azurerm_role_assignment.security_reader.role_definition_name 
}